/*******************************************************************************
  MPLAB I2C bit bang file that maintains the queue

  Company:
    Microchip Technology Inc.

  File Name:
    i2c_queue.h

  Summary:
    Contains prototype for
*******************************************************************************/

// DOM-IGNORE-BEGIN
/*******************************************************************************
Copyright (c) 2013 released Microchip Technology Inc.  All rights reserved.

Microchip licenses to you the right to use, modify, copy and distribute
Software only when embedded on a Microchip microcontroller or digital signal
controller that is integrated into your product or third party product
(pursuant to the sublicense terms in the accompanying license agreement).

You should refer to the license agreement accompanying this Software for
additional information regarding your rights and obligations.

SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
(INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.
*******************************************************************************/
// DOM-IGNORE-END

#ifndef I2C_QUEUE_H
#define	I2C_QUEUE_H

// *****************************************************************************
// *****************************************************************************
// Section: Included Files
// *****************************************************************************
// *****************************************************************************

#include <stdint.h>
#include <stdlib.h>
#include <stdbool.h>
#include "main.h"
#include "i2c_bitbang_isr.h"

// *****************************************************************************
// *****************************************************************************
// Section: Function Prototypes
// *****************************************************************************
// *****************************************************************************

#define MAX_NUMBER_OF_QUEUE_ELEMENTS            6

extern BUFFER_TRANSFER_QUEUE BTQ_Message[MAX_NUMBER_OF_QUEUE_ELEMENTS] ;

extern BUFFER_TRANSFER_QUEUE* queue[MAX_NUMBER_OF_QUEUE_ELEMENTS];

extern volatile uint16_t QueueIn;
extern volatile uint16_t QueueOut;
extern volatile uint16_t QueueDelta;

void QueueInitialize(void);

BUFFER_TRANSFER_QUEUE* GetNextQueueItem(void);

uint32_t  GetNumberOfFreeSlots(void);

bool AddNewQueueItem(BUFFER_TRANSFER_QUEUE* BTQ_IN);

uint32_t  GetNumberofQueueEntires(void);

bool IsQueueEmpty(void);


#endif	/* I2C_QUEUE_H */


/*******************************************************************************
 End of File
*/

